---
title: Guides
id: README
original_id: README
---

- 🔰 Basics
  - [Handling loading state](guides/loading-state.md)
  - [Dealing with network errors](guides/network-errors.md)
  - [Fetching multiple resources at once](guides/fetch-multiple.md)
  - [Pagination](guides/pagination.md)
  - [Understanding Immutability](guides/immutability.md)
  - [Mocking unfinished endpoints](guides/mocking-unfinished.md)
- 🖧 Defining your network interface
  - [Defining your Resource types](guides/resource-types.md)
  - [Computed properties](guides/computed-properties.md)
  - [Multicolumn primary keys](guides/multi-pk.md)
  - [Transforming data on network load](guides/network-transform.md)
  - [Authentication](guides/auth.md)
  - [Cross-orgin requests with JSONP](guides/jsonp.md)
  - [Custom networking library](guides/custom-networking.md)
  - [Custom cache lifetime](guides/resource-lifetime.md)
- 💨 Performance Optimizations (optional)
  - [Nesting related resources (server-side join)](guides/nested-response.md)
  - [Cross-resource multi-update RPC (dealing with side-effects)](guides/rpc.md)
- Integrations
  - [Redux integration](guides/redux.md)
